// DemoMFCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DemoMFC.h"
#include "DemoMFCDlg.h"
#include "FRB.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern WORD wTotalBoards;

/////////////////////////////////////////////////////////////////////////////
// CDemoMFCDlg dialog

CDemoMFCDlg::CDemoMFCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoMFCDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoMFCDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemoMFCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoMFCDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoMFCDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoMFCDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_BN_CLICKED(IDC_Active, OnActive)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoMFCDlg message handlers

BOOL CDemoMFCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	//SetDlgItemText(IDC_BASEADDR, TEXT("2A0") );
	SetDlgItemInt(IDC_TOTAL, wTotalBoards );
	SetDlgItemInt(IDC_SELECT, 0 );
	SetDlgItemInt(IDC_ePort, 0 );
	SetDlgItemInt(IDC_eSA, 0 );
	SetDlgItemInt(IDC_eRA, 8 );

	SetDlgItemText(IDC_DI0, TEXT("0") );
	SetDlgItemText(IDC_DO0, TEXT("A5A5") );

	if ( wTotalBoards < 1 ) {
		MessageBox( "Card Not Found!!" );
		(CButton*)GetDlgItem(IDC_Active)->EnableWindow( FALSE );
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDemoMFCDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDemoMFCDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDemoMFCDlg::OnOK() 
{
	// TODO: Add extra validation here
	
}

void CDemoMFCDlg::OnExit() 
{
	// TODO: Add your control notification handler code here
	
	CDialog::OnOK();
}

void CDemoMFCDlg::OnActive() 
{
	// TODO: Add your control notification handler code here
	WORD wVal, wSelect, wRtn,wPort,wSAn,wRAn;
	WORD wBoardNo;

	wBoardNo = GetDlgItemInt(IDC_SELECT);
	 
	wPort = GetDlgItemInt(IDC_ePort);
	wSAn = GetDlgItemInt(IDC_eSA);
	wRAn = GetDlgItemInt(IDC_eRA);
 
	// Digital-Output 
	wVal = GetDlgItemHex(IDC_DO0);
    wRtn=FRB_SendSABoard(wBoardNo, wPort, wSAn, wVal );

	Sleep(50);
	// Digital-Input
	wRtn=FRB_ReceiveRABoard(wBoardNo, wPort, wRAn, &wVal );
	SetDlgItemHex(IDC_DI0, wVal);

	//TRACE( "wBase = %d\n", wBase );
}

WORD CDemoMFCDlg::GetDlgItemHex(int nID)
{
	static const int nLength = 10;
	CString str;
	char szStr[nLength], * stopstring;
	
	GetDlgItemText(nID, str);
	strcpy(szStr, str.GetBuffer(nLength) );
	return (WORD) strtoul( szStr, &stopstring, 16 );
}


void CDemoMFCDlg::SetDlgItemHex(int nID, WORD nHex)
{
	static const int nLength = 10;
	char string[nLength];

	_ltoa( nHex, string, 16 );
	SetDlgItemText(nID, string);
}
